/* Copyright (c) 2006 Bradley C. Kuszmaul */
#include "ptrans-base.h"

void ptrans_base (double *A, const double *B, int rowlen, int arows, int brows) {
 double tmp[BASE][BASE];
   int i,j;
   for (j=0; j<arows; j++) {
     for (i=0; i<brows; i++) {
       tmp[i][j] = B[i+rowlen*j];
     }
   }
   for (i=0; i<arows; i++) {
     for (j=0; j<brows; j++) {
       A[j+i*rowlen] += tmp[i][j];
     }
   }
}
